#include "descriptor/descriptor.h"



float color_integer2decimal(int val)
{
	return (val / 255.0);
}

int main(void) {

  	// ELEMENTI DELLA SCENA

  // Elenco Oggetti
  ITEM	scene;

  ITEM	samovar, samovar_corpo, samovar_chiusura_alto, samovar_coperchio, samovar_piedistallo,
	rubinetto, blocca_flusso_base, blocca_flusso_coperchio, blocca_flusso_manico, blocca_flusso_manico_coperchio, blocca_flusso_middle,
	blocca_flusso_piolo, blocca_flusso_up,
	manico_base_sx,	manico_base_dx, manico_piolo1_sx, manico_piolo1_dx, manico_piolo2_sx, manico_piolo2_dx;

  ITEM  trofeo, base_trofeo, collo_giraffa, testa_giraffa;

  ITEM	tavolo, tavolo_superficie, tavolo_gamba;

  ITEM	tazze, tazza1, tazza1_manico, tazza2, tazza2_manico;

  ITEM	stanza, parete_trofeo, parete_trofeo_sx, parete_trofeo_dx, parete_trofeo_front, pavimento, soffitto;

  // Elenco Attributi
  ITEM	void_attribute, ceramica, intonaco, silver, manicolor, ghisa, legno, metallo, parquet, porcellana, blu, verdino;

  // Elenco Luci
  ITEM	luce_lato, luce_alto, luce_fronte;

  	// DEFINIZIONE LUCI

  set_background(0.75, 1.0, 0.66, TRUE);
  set_ambient_light(1, 1, 1, 0.7);
  luce_lato 	= create_point_light(11.0, 11.0, -0.6, 1, 1, 1, 3.89, 40, "luce_lato");
  luce_fronte 	= create_point_light(1.1, 21.0, -0.3, 1, 1, 1, 4, 40, "luce_fronte");
  luce_alto 	= create_point_light(-0.972, -8.155, 35.714, 1, 1, 1, 3.89, 25, "luce_alto");

	// ATTRIBUTO VOID (che sfrutto quando carico le texture)
  void_attribute = create_attribute("standard");

  	// ATTRIBUTO Ceramica
  ceramica = create_attribute("ceramica");
  set_color(ceramica,0.89,0.76,0.65,0.1,0.3);
  set_reflectivity(ceramica,0.2,128);

  	// ATTRIBUTO Legno
  legno = create_attribute("legno");
  set_color(legno,0.6,0.4,0.3,0.1,0.8);
  set_reflectivity(legno,0.1,100);

	// ATTRIBUTO Metallo
  metallo = create_attribute("metallo");
  set_color(metallo,0.72,0.72,0.72,0.1,0.449);
  set_reflectivity(metallo,0.2,128);

	// ATTRIBUTO Parquet
  parquet = create_attribute("parquet");
  set_color(parquet,1,0.69,0.4,0.1,0.7);
  set_reflectivity(parquet,0.05,25);

  	// ATTRIBUTO Intonaco
  intonaco = create_attribute("intonaco");
  set_color(intonaco, 0.83, 0.82, 0.8, 0.1, 0.35);
  set_reflectivity(intonaco, 0, 12);

  	// ATTRIBUTO silver
  silver = create_attribute("silver");
  set_color(silver, 0.843, 0.909, 0.929, 0.2, 0.3);
  set_reflectivity(silver, 0, 130);

  	// ATTRIBUTO manicolor
  manicolor = create_attribute("manicolor");
  set_color(manicolor, 0.643, 0, 0.404, 0.2, 0.2);
  set_reflectivity(manicolor, 0.1, 2);

  	// ATTRIBUTO ghisa
  ghisa = create_attribute("ghisa");
  set_color(ghisa, color_integer2decimal(32), color_integer2decimal(0), color_integer2decimal(0), 0.25, 0.25);
  set_reflectivity(ghisa, 0.1, 2);

  	// ATTRIBUTO verdino
  verdino = create_attribute("verdino");
  set_color(verdino, color_integer2decimal(183), color_integer2decimal(255), color_integer2decimal(214), 0.25, 0.25);
  set_reflectivity(verdino, 0, 2);


  	// TROFEO

  base_trofeo 		= read_nurbs("base.db");
  collo_giraffa 	= read_nurbs("collo_giraffa.db");
  testa_giraffa 	= read_obj("testa_giraffa_new.obj", "testa_giraffa");

  //set_attribute(base_trofeo, legno);
  set_domain_texture(base_trofeo, legno, "textures/venature.hr", 0.01, 0.99, 0.01, 0.99, 1, 0.2, 0.3);
  set_domain_texture(collo_giraffa, void_attribute, "textures/giraffe.hr", 0.01, 0.99, 0.01, 0.99, 1, 0.2, 0.3);
  set_attribute(testa_giraffa, legno);

  trofeo = create_list(base_trofeo, "trofeo");
  trofeo = insert_in_list(trofeo, collo_giraffa);
  trofeo = insert_in_list(trofeo, testa_giraffa);

  	// SAMOVAR

  samovar_corpo= read_nurbs("samovar_corpo.db");
  samovar_piedistallo= read_nurbs("piedistallo.db");
  samovar_chiusura_alto= read_nurbs("samovar_chiusura_alto.db");
  samovar_coperchio= read_nurbs("samovar_coperchio.db");
  rubinetto= read_nurbs("rubinetto.db");
  blocca_flusso_base= read_nurbs("blocca_flusso_base_new.db");
  blocca_flusso_coperchio= read_nurbs("blocca_flusso_coperchio_new.db");
  blocca_flusso_manico= read_nurbs("blocca_flusso_manico.db");
  blocca_flusso_manico_coperchio= read_nurbs("blocca_flusso_manico_coperchio.db");
  blocca_flusso_middle= read_nurbs("blocca_flusso_middle_new.db");
  blocca_flusso_piolo= read_nurbs("blocca_flusso_piolo.db");
  blocca_flusso_up= read_nurbs("blocca_flusso_up_new.db");
  manico_base_sx= read_nurbs("manico_base_sx.db");
  manico_base_dx= read_nurbs("manico_base_dx.db");
  manico_piolo1_sx= read_nurbs("manico_piolo1_sx.db");
  manico_piolo1_dx= read_nurbs("manico_piolo1_dx.db");
  manico_piolo2_sx= read_nurbs("manico_piolo2_sx.db");
  manico_piolo2_dx= read_nurbs("manico_piolo2_dx.db");

  set_attribute(samovar_corpo, silver);
  set_attribute(samovar_piedistallo, silver);
  set_attribute(samovar_chiusura_alto, silver);
  set_attribute(samovar_coperchio, manicolor);
  set_attribute(rubinetto, silver);
  set_attribute(blocca_flusso_base, silver);
  set_attribute(blocca_flusso_coperchio, manicolor);
  set_attribute(blocca_flusso_manico, silver);
  set_attribute(blocca_flusso_manico_coperchio, manicolor);
  set_attribute(blocca_flusso_middle, silver);
  set_attribute(blocca_flusso_piolo, silver);
  set_attribute(blocca_flusso_up, silver);
  set_attribute(manico_base_sx, silver);
  set_attribute(manico_base_dx, silver);
  set_attribute(manico_piolo1_sx, manicolor);
  set_attribute(manico_piolo1_dx, manicolor);
  set_attribute(manico_piolo2_sx, manicolor);
  set_attribute(manico_piolo2_dx, manicolor);

  samovar = create_list(samovar_corpo, "samovar");
  samovar = insert_in_list(samovar, samovar_piedistallo);
  samovar = insert_in_list(samovar, samovar_chiusura_alto);
  samovar = insert_in_list(samovar, samovar_coperchio);
  samovar = insert_in_list(samovar, rubinetto);
  samovar = insert_in_list(samovar, blocca_flusso_base);
  samovar = insert_in_list(samovar, blocca_flusso_coperchio);
  samovar = insert_in_list(samovar, blocca_flusso_manico);
  samovar = insert_in_list(samovar, blocca_flusso_manico_coperchio);
  samovar = insert_in_list(samovar, blocca_flusso_middle);
  samovar = insert_in_list(samovar, blocca_flusso_piolo);
  samovar = insert_in_list(samovar, blocca_flusso_up);
  samovar = insert_in_list(samovar, manico_base_sx);
  samovar = insert_in_list(samovar, manico_base_dx);
  samovar = insert_in_list(samovar, manico_piolo1_sx);
  samovar = insert_in_list(samovar, manico_piolo1_dx);
  samovar = insert_in_list(samovar, manico_piolo2_sx);
  samovar = insert_in_list(samovar, manico_piolo2_dx);

  	// TAVOLO

  tavolo_superficie 	= read_nurbs("tavolo_superficie.db");
  tavolo_gamba 		= read_nurbs("tavolo_gamba.db");
  set_domain_texture(tavolo_superficie, void_attribute, "textures/marble_black.hr", 0.01, 0.99, 0.01, 0.99, 1, 0.2, 0.3);
  set_attribute(tavolo_gamba, ghisa);

  tavolo = create_list(tavolo_superficie, "tavolo");
  tavolo = insert_in_list(tavolo, tavolo_gamba);


  	// TAZZE

  tazza1 	= read_nurbs("tazza1.db");
  tazza1_manico = read_nurbs("tazza1_manico.db");
  tazza2 	= read_nurbs("tazza2_corpo.db");
  tazza2_manico = read_nurbs("tazza2_manico.db");
  set_attribute(tazza1, ceramica);
  set_attribute(tazza1_manico, ceramica);
  set_attribute(tazza2, ceramica);
  set_attribute(tazza2_manico, ceramica);

  tazze = create_list(tazza1, "tazze");
  tazze = insert_in_list(tazze, tazza1_manico);
  tazze = insert_in_list(tazze, tazza2);
  tazze = insert_in_list(tazze, tazza2_manico);


  	// STANZA

  parete_trofeo 	= read_nurbs("parete_trofeo.db");
  parete_trofeo_sx 	= read_nurbs("parete_trofeo_sx.db");
  parete_trofeo_dx 	= read_nurbs("parete_trofeo_dx.db");
  parete_trofeo_front 	= read_nurbs("parete_trofeo_front.db");
  pavimento		= read_nurbs("pavimento.db");
  soffitto		= read_nurbs("soffitto.db");

  set_attribute(parete_trofeo, intonaco);
  set_attribute(parete_trofeo_sx, intonaco);
  set_attribute(parete_trofeo_dx, intonaco);
  set_attribute(parete_trofeo_front, intonaco);
  set_projection_texture(pavimento, void_attribute, "textures/oak_golden.hr", 0, 1, 0.1, 1);
  set_attribute(soffitto, intonaco);

  stanza = create_list(parete_trofeo, "stanza");
  stanza = insert_in_list(stanza, parete_trofeo_dx);
  stanza = insert_in_list(stanza, pavimento);
  stanza = insert_in_list(stanza, soffitto);


	// SCENA FINALE

  scene = create_list(samovar, "scene");
  scene = insert_in_list(scene, trofeo);
  scene = insert_in_list(scene, tavolo);
  scene = insert_in_list(scene, tazze);
  scene = insert_in_list(scene, stanza);
  save_scene("scena1.md", "scene_samovar", scene);
  return(0);
}
